     ;import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class robot here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class robot extends Actor
{
    private GreenfootImage robotImage1 = new GreenfootImage("man01.png");
    private GreenfootImage robotImage2 = new GreenfootImage("man02.png");
    private GreenfootImage gameOverImage = new GreenfootImage("gameover.png");
    private int animateCounter = 0;
    public int lives = 3;
    private int score = 0;
    private int energyConsumed = 0;
    private int timer;
    private final int MAXTIMER = 1000;
    private int currentLevel=1;
    private boolean soundHasPlayed = false;
    private GreenfootSound music;
    
    
    /**
     * Act - do whatever the robot wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        robotMovement();
        detectHome();
        increaseEnergy();
        updateTimer();
        detectEnemyCollision();
        balloonTouch();
        if (!soundHasPlayed)
        /**
         * checks if backgrund muisc has played once, if true, it wont play
         * again until game is reset
         */
        {
         GreenfootSound gfs = new GreenfootSound("music.mp3");  
        gfs.setVolume(50);  
        gfs.play(); 
         
           
           soundHasPlayed = true;
        }
        Actor block_2;
        block_2 = getOneObjectAtOffset(0,0,block_2.class);
        if(block_2 !=null)
        /**
         * Checks if the block_2 actor exists, and if it does
         * it deletes block_2 if robot touches it
         * The (0,0) coordinate rspresents the exact location of the robot
         */
        {
             RobotWorld world = (RobotWorld)getWorld();
             world.removeObject(block_2);
             Greenfoot.playSound("boom.mp3");
        }
        showStatus();
    }
    private void balloonTouch()
    /**
     *If the robot is touching the balloon actor, it is removed from the world.
     *Once the balloon is removed (which is at 325, 511), the game 
     *realizes there is nothing there so it allows the robot actor to come
     *into contact with block_2, if it is pressing left button.
     */
    {
         if (isTouching(balloon.class))
       {
         removeTouching(balloon.class);     
         Greenfoot.playSound("pop.mp3");
       }
        if (!getWorld().getObjectsAt(325,551, null).isEmpty()) 
       {
              if (isTouching(wall.class)){
                setLocation(getX()+3,getY());
             }
             if (isTouching(block_2.class)){
                setLocation(getX()+3,getY());
              } 
              
       }
    }
    private void detectEnemyCollision() {
        /**
         * If the robot touches any of these actors, it loses a life and a 
         * sound is played
         */
        if (isTouching(enemy.class)) {
            Greenfoot.playSound("death.mp3");
            setLocation(30,50);
            removeLife();
        }
        if (isTouching(enemy_2.class)) {
            Greenfoot.playSound("death.mp3");
            setLocation(30,50);
            removeLife();
        }
        if (isTouching(bullet.class)) {
            Greenfoot.playSound("death.mp3");
            setLocation(30,50);
            removeLife();
        }
        if (isTouching(block.class)){
            Greenfoot.playSound("death.mp3");
            setLocation(29, 48);
            removeLife();
        }
    }
    private void resetTimer()
    /**
     * When timer is reset, sets time to MAXTIMER (1000)
     */
    {
        timer = MAXTIMER;
        
    }
    private void updateTimer()
    /**
     * puts timer text on screen and checks if timer <1, if it is timer 
     * is reset, life is removed, and location set back to original position
     */
    {
        timer--;
        getWorld().showText("Time Left: "+timer, 720, 45);
        if (timer < 1) {
            removeLife();
            resetTimer();
            setLocation(39,35);
            }
        
        
            
    }
    private void showStatus()
    /** 
     * shows score and lives on screen (bottom left)
     */
    {
        getWorld().showText("Lives : " +lives, 70,540);
        getWorld().showText("Score : " +score, 70,560);
    }
    private void increaseScore()
    /**
     * increase score and updates status
     */
    {
        score++;
        showStatus();
    }
    private void testEndGame()
    /**
     * If lives < 0, game over image is shown and program is stopped
     */
    {
        if (lives < 0) {
            setImage(gameOverImage);
            Greenfoot.stop();
            
        }
    }
    private void removeLife() {
        /**
         * removes a life, updates status, and checks testEndGame (if the 
         * game is over)
         */
        lives--;
        testEndGame();
        showStatus();
    }
    private void animate()
    /**
     * gives robot movement animated look by alternating images
     */
    {
        animateCounter++;
        if (animateCounter > 5) {
            if (getImage() == robotImage1) {
                setImage(robotImage2);
            }
            else {
                setImage(robotImage1);
            }
        }
    }
    public void increaseLevel()
    /**
     * increase level
     */
    {
        currentLevel++;
        setUpLevel();
    }
    private void detectHome()
    /**
     *if is touching home actor and requirements are met, changes level,
     *position,energyConsumed,plays sound,increases score,and resets timer
     */
    {
        if (isTouching(home.class) && energyConsumed ==3){
            Greenfoot.playSound("yipee.mp3");
            setLocation(27,75);
            energyConsumed = 0;
            increaseScore();
            RobotWorld myWorld = (RobotWorld)getWorld();
            myWorld.increaseLevel();
            myWorld.setUpLevel();
            resetTimer();
        
        }
        else if (isTouching(home.class) && energyConsumed ==9){
             
             increaseScore();
             RobotWorld myWorld = (RobotWorld)getWorld();
             myWorld.increaseLevel();
             myWorld.setUpLevel();
             resetTimer();
             getWorld().setBackground(new GreenfootImage("win.jpg"));
             
        
            }
    }
    private void setUpLevel()
    /**
     * checks current level and does what is written based on
     * what level it is.
     */
    {
        if (currentLevel == 2){
            if (isTouching(home.class) && energyConsumed ==9){
             Greenfoot.playSound("yipee.mp3");
             increaseScore();
             RobotWorld myWorld = (RobotWorld)getWorld();
             myWorld.increaseLevel();
             myWorld.setUpLevel();
             resetTimer();
             
             
            }
        }
    }
    public void increaseEnergy()
    /**
     * if robot is touching energ; plays sound, increases time,energy 
     * consumed variable, and removes energy.
     */
    {

        if (isTouching(energy.class)) {
            Greenfoot.playSound("num.mp3");
            removeTouching(energy.class);
            energyConsumed++;
            timer = timer +600;
        }
    }
    private void robotMovement(){
        /**
         * allows robot to move 3 pixels in whatever direction is pressed,
         * as long as there arent any exceptions like a wall or block_2
         */
        if (Greenfoot.isKeyDown("right")){
            setLocation(getX()+3,getY());
            if (isTouching(wall.class)){
                setLocation(getX()-3,getY());
            }
            if (isTouching(block_2.class)){
                setLocation(getX()-3,getY());
            }
            animate();
            
        }
         if (Greenfoot.isKeyDown("left")){
               setLocation(getX()-3,getY());
               if (isTouching(wall.class)){
                  setLocation(getX()+3,getY());
               }
               if (isTouching(block_2.class)){
                  setLocation(getX(),getY());
                }
              
               animate();
               
       }
        if (Greenfoot.isKeyDown("up")){
            setLocation(getX(),getY()-3);
            if (isTouching(wall.class)){
                setLocation(getX(),getY()+3);
            }
            if (isTouching(block_2.class)){
                setLocation(getX(),getY()+3);
            }
            animate();
            
        }
        if (Greenfoot.isKeyDown("down")){
            
            setLocation(getX(),getY()+3);
            if (isTouching(wall.class)){
                setLocation(getX(),getY()-3);
            }
            if (isTouching(block_2.class)){
                setLocation(getX(),getY()-3);
            }
            animate();
            
        }
    }
}
